#!/bin/sh

DATABASE="is_proj1"

# generate benchmark data
cd dbgen
./dbgen -s 1 -f

# recreate db
dropdb --if-exists --echo $DATABASE
createdb --echo $DATABASE

# create tables
psql $DATABASE -f ../row_tables.sql

for tbl in *.tbl; do 
    echo "Importing: $tbl"

    # remove trailing pipe symbol
    sed -i 's/|$//' "$tbl"
    
    # table name and absolute path for pgsql
    tbl_name=$(basename -s .tbl $tbl)
    tbl_file=$(realpath $tbl)

    psql $DATABASE -c "copy $tbl_name from '$tbl_file' WITH DELIMITER AS '|';"
done

# free space
rm *.tbl

# define primary keys and foreign keys
psql $DATABASE -f ../row_keys.sql

echo "Creating Simple Column Schema..."
psql $DATABASE -f ../sc_tables.sql

echo "Creating Indexed Simple Column Schema..."
psql $DATABASE -f ../sc_idx_tables.sql

echo "Creating Materialised View Schema..."


echo "Creating C-Tables..."

echo "Cleaning..."
psql $DATABASE -c "vacuum;"
