-- count of items shipped each day after D
PREPARE MV_Q1 (date) AS 
    SELECT l_shipdate, count
    FROM MV_Q1 
    WHERE l_shipdate > $1;

-- count of items shipped for each supplier on day D
PREPARE MV_Q2 (date) AS     
    SELECT l_suppkey, count
    FROM MV_Q2_Q3 
    WHERE l_shipdate = $1;
    
-- count of items shipped for each supplier after day D
PREPARE MV_Q3 (date) AS     
    SELECT l_suppkey, SUM(count)
    FROM MV_Q2_Q3 
    WHERE l_shipdate > $1
    GROUP BY l_suppkey;
    
-- latest shipdate of all items ordered after each day D    
PREPARE MV_Q4 (date) AS 
    SELECT o_orderdate, max
    FROM MV_Q4 
    WHERE o_orderdate > $1;

-- for each supplier, latest shipdate of an item from an order that was made on day D
PREPARE MV_Q5 (date) AS 
    SELECT l_suppkey, max
    FROM MV_Q5_Q6 
    WHERE o_orderdate = $1;
    
-- for each supplier, latest ship date of an item from an order that was made after day D    
PREPARE MV_Q6 (date) AS
    SELECT l_suppkey, MAX(max)
    FROM MV_Q5_Q6 
    WHERE o_orderdate > $1
    GROUP BY l_suppkey;
    
-- Nations for customers (along with lost revenue) for parts that they returned
PREPARE MV_Q7 AS     
    SELECT c_nationkey, sum
    FROM MV_Q7 
    WHERE  l_returnflag='R';
