-- count of items shipped each day after D
PREPARE Q1 (date) AS 
    SELECT l_shipdate, COUNT (*)
    FROM lineitem
    WHERE l_shipdate > $1
    GROUP BY l_shipdate;

-- count of items shipped for each supplier on day D
PREPARE Q2 (date) AS
    SELECT l_suppkey, COUNT (*)
    FROM lineitem
    WHERE l_shipdate = $1
    GROUP BY l_suppkey;
    
-- count of items shipped for each supplier after day D
PREPARE Q3 (date) AS
    SELECT l_suppkey, COUNT (*)
    FROM lineitem
    WHERE l_shipdate > $1
    GROUP BY l_suppkey;
    
-- latest shipdate of all items ordered after each day D    
PREPARE Q4 (date) AS
    SELECT o_orderdate, MAX (l_shipdate)
    FROM lineitem, orders
    WHERE l_orderkey=o_orderkey AND o_orderdate > $1
    GROUP BY o_orderdate;

-- for each supplier, latest shipdate of an item from an order that was made on day D
PREPARE Q5 (date) AS
    SELECT l_suppkey, MAX (l_shipdate)
    FROM lineitem, orders
    WHERE l_orderkey=o_orderkey AND o_orderdate = $1
    GROUP BY l_suppkey;
    
-- for each supplier, latest ship date of an item from an order that was made after day D
PREPARE Q6 (date) AS
    SELECT l_suppkey, MAX (l_shipdate)
    FROM lineitem, orders
    WHERE l_orderkey=o_orderkey AND o_orderdate > $1
    GROUP BY l_suppkey;
    
-- Nations for customers (along with lost revenue) for parts that they returned
PREPARE Q7 AS
    SELECT c_nationkey, SUM(l_extendedprice)
    FROM lineitem, orders, customer
    WHERE l_orderkey=o_orderkey AND o_custkey=c_custkey AND l_returnflag='R'
    GROUP BY c_nationkey;
